﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Data;
using Infragistics.Windows.DataPresenter;
using System.Windows.Threading;

namespace Grid_SyncHeaders
{
    public class Person
    {
        public string Name { get; set; }
        public int Age { get; set; }
        public ObservableCollection<Infant> Children { get; private set; }

        public Person()
        {
            Children = new ObservableCollection<Infant>();
        }
    }

    public class Infant
    {
        public string Name { get; set; }
        public int Age { get; set; }
    }

    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {

        public ObservableCollection<Person> People { get; private set; }

        public MainWindow()
        {
            InitializeComponent();

            People = new ObservableCollection<Person>();
            var p = new Person {Age = 50, Name = "Mary"};
            p.Children.Add(new Infant {Age = 7, Name = "Terry"});
            p.Children.Add(new Infant { Age = 3, Name = "Jane" });
            People.Add(p);
            xamDataGrid1.DataSource = People;
            xamDataGrid2.DataSource = People;
            /*
            DataSet data = new DataSet();

            DataTable table1 = new DataTable();

            DataColumn colid = new DataColumn();
            colid.ColumnName = "ID";
            colid.DataType = typeof(int);
            table1.Columns.Add(colid);
            DataColumn col1 = new DataColumn();
            col1.ColumnName = "Name";
            col1.DataType = typeof(string);
            table1.Columns.Add(col1);
            DataColumn col2 = new DataColumn();
            col2.ColumnName = "Age";
            col2.DataType = typeof(int);
            table1.Columns.Add(col2);

            table1.Rows.Add(new object[] { 1, "Steve", 21 });
            table1.Rows.Add(new object[] { 2, "John", 52 });
            table1.Rows.Add(new object[] { 3, "Dane", 37 });
            


            DataTable table2 = new DataTable();
            //table1.TableName = "R";

            DataColumn colid2 = new DataColumn();
            colid2.ColumnName = "ID2";
            colid2.DataType = typeof(int);
            table2.Columns.Add(colid2);
            DataColumn col11 = new DataColumn();
            col11.ColumnName = "Child Name";
            col11.DataType = typeof(string);
            table2.Columns.Add(col11);
            DataColumn col12 = new DataColumn();
            col12.ColumnName = "Child Age";
            col12.DataType = typeof(int);
            table2.Columns.Add(col12);

            table2.Rows.Add(new object[] { 1, "Steve Jr", 21 });
            table2.Rows.Add(new object[] { 1, "Steve Jr2", 21 });
            table2.Rows.Add(new object[] { 2, "John Jr", 21 });
            table2.Rows.Add(new object[] { 2, "John Jr", 21 });
            table2.Rows.Add(new object[] { 3, "Cat", 21 });



            data.Tables.Add(table1);
            data.Tables.Add(table2);
            data.Relations.Add(new DataRelation("bla", colid, colid2));

            xamDataGrid1.DataSource = data.Tables[0].DefaultView;*/
        }

        void LabelPresenters_SizeChanged(object sender, SizeChangedEventArgs e)
        {
            LabelPresenter lp = sender as LabelPresenter;

            if (xamDataGrid1.FieldLayouts[0].Fields.Contains(lp.Field))
            {
                Field f = this.xamDataGrid1.FieldLayouts[1].Fields[lp.Field.Index];
                f.Width = new FieldLength(lp.Field.CellWidthResolved);
            }

            if (xamDataGrid1.FieldLayouts[1].Fields.Contains(lp.Field))
            {
                Field f = this.xamDataGrid1.FieldLayouts[0].Fields[lp.Field.Index];
                f.Width = new FieldLength(lp.Field.CellWidthResolved);
            }

        }

        void LabelPresenters_SizeChanged2(object sender, SizeChangedEventArgs e)
        {
            LabelPresenter lp = sender as LabelPresenter;

            if (xamDataGrid2.FieldLayouts[0].Fields.Contains(lp.Field))
            {
                Field f = this.xamDataGrid2.FieldLayouts[1].Fields[lp.Field.Index];
                f.Width = new FieldLength(lp.Field.CellWidthResolved);
            }

            if (xamDataGrid2.FieldLayouts[1].Fields.Contains(lp.Field))
            {
                Field f = this.xamDataGrid2.FieldLayouts[0].Fields[lp.Field.Index];
                f.Width = new FieldLength(lp.Field.CellWidthResolved);
            }

        }

        private void xamDataGrid1_FieldPositionChanged(object sender, Infragistics.Windows.DataPresenter.Events.FieldPositionChangedEventArgs e)
        {

            if (xamDataGrid1.FieldLayouts[0].Fields.Contains(e.Field))
            {
                foreach (Field field in this.xamDataGrid1.FieldLayouts[0].Fields)
                {
                    if (field.Index < this.xamDataGrid1.FieldLayouts[1].Fields.Count)
                    {
                        Field field2 = this.xamDataGrid1.FieldLayouts[1].Fields[field.Index];
                        field2.ActualPosition = new FieldPosition(field.ActualPosition.Column, field.ActualPosition.Row, field.ActualPosition.ColumnSpan, field.ActualPosition.RowSpan);
                    }
                }
            }

            if (xamDataGrid1.FieldLayouts[1].Fields.Contains(e.Field))
            {
                foreach (Field field in this.xamDataGrid1.FieldLayouts[1].Fields)
                {
                    Field field2 = this.xamDataGrid1.FieldLayouts[0].Fields[field.Index];
                    field2.ActualPosition = new FieldPosition(field.ActualPosition.Column, field.ActualPosition.Row, field.ActualPosition.ColumnSpan, field.ActualPosition.RowSpan);
                }
            }
        }

        private void xamDataGrid2_FieldPositionChanged(object sender, Infragistics.Windows.DataPresenter.Events.FieldPositionChangedEventArgs e)
        {

            if (xamDataGrid2.FieldLayouts[0].Fields.Contains(e.Field))
            {
                foreach (Field field in this.xamDataGrid2.FieldLayouts[0].Fields)
                {
                    if (field.Index < this.xamDataGrid2.FieldLayouts[1].Fields.Count)
                    {
                        Field field2 = this.xamDataGrid2.FieldLayouts[1].Fields[field.Index];
                        field2.ActualPosition = new FieldPosition(field.ActualPosition.Column, field.ActualPosition.Row, field.ActualPosition.ColumnSpan, field.ActualPosition.RowSpan);
                    }
                }
            }

            if (xamDataGrid2.FieldLayouts[1].Fields.Contains(e.Field))
            {
                foreach (Field field in this.xamDataGrid2.FieldLayouts[1].Fields)
                {
                    Field field2 = this.xamDataGrid2.FieldLayouts[0].Fields[field.Index];
                    field2.ActualPosition = new FieldPosition(field.ActualPosition.Column, field.ActualPosition.Row, field.ActualPosition.ColumnSpan, field.ActualPosition.RowSpan);
                }
            }
        }

       
    }
}
